stages:
  - preparation
  - testing
  - security

image: edbizarro/gitlab-ci-pipeline-php:7.3

cache:
  key: "$CI_JOB_NAME-$CI_COMMIT_REF_SLUG"
  paths:
    - vendor/
    - composer.lock

composer:
  stage: preparation
  script:
    - php -v
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress --no-scripts
  artifacts:
    paths:
      - vendor/
      - composer.lock
    expire_in: 1 days
    when: always

php linter:
  stage: testing
  image: pipelinecomponents/php-linter:latest
  cache: {}
  script:
    - parallel-lint --exclude vendor --colors .

php stan:
  stage: testing
  dependencies:
    - composer
  script:
    - composer phpstan | tee phpstan_results.txt
  artifacts:
    when: always
    expire_in: 1 week
    paths:
    - phpstan_results.txt

php cpd:
  stage: testing
  dependencies:
    - composer
  script:
    - composer phpcpd | tee phpcpd_results.txt
  artifacts:
    when: always
    expire_in: 1 week
    paths:
    - phpcpd_results.txt

php unit:
  stage: testing
  only:
    - master
    - tags
  dependencies:
    - composer
  before_script:
    - sudo pecl install xdebug
    - sudo docker-php-ext-enable xdebug
  script:
    - php -v
#    - sudo cp /usr/local/etc/php/conf.d/docker-php-ext-xdebug.ini /usr/local/etc/php/conf.d/docker-php-ext-xdebug.bak
#    - echo "" | sudo tee /usr/local/etc/php/conf.d/docker-php-ext-xdebug.ini
    - ./vendor/phpunit/phpunit/phpunit --version
    - php -d short_open_tag=off ./vendor/phpunit/phpunit/phpunit --testsuite All --coverage-text --colors=never --stderr
#    - sudo cp /usr/local/etc/php/conf.d/docker-php-ext-xdebug.bak /usr/local/etc/php/conf.d/docker-php-ext-xdebug.ini
  artifacts:
    paths:
      - ./storage/logs
    expire_in: 1 days
    when: on_failure

sensiolabs:
  stage: security
  script:
    - test -d security-checker || git clone https://github.com/sensiolabs/security-checker.git
    - cd security-checker
    - composer install
    - php security-checker security:check ../composer.lock
  dependencies:
    - composer
  cache:
    paths:
      - security-checker/
